//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#include <Arrays\ArrayInt.mqh>
#include <Arrays\ArrayDouble.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   srand(_RandomSeed);
   int iterations=(int)pow(10,8);
   CArrayDouble   arrD1;
   CArrayDouble   arrD2;
   CArrayInt      arrI1;
   CArrayInt      arrI2;
   arrD1.Reserve(iterations);
   arrI1.Reserve(iterations);
   arrD2.Reserve(iterations);
   arrI2.Reserve(iterations);

   for(int i=0;i<iterations;i++)
     {
      arrI1.Add(rand()%50000);
      arrI2.Add(rand()%50000);
     }
   for(int i=0;i<iterations;i++)
     {
      arrD1.Add((double)arrI1[i]);
      arrD2.Add((double)arrI2[i]);
     }

///TESTING INT
   long result=0;
   long sumi=0;
   ulong m=GetMicrosecondCount();
   for(int i=0;i<iterations;i++)
     {
      int v=Add(arrI1[i],arrI2[i]);
      sumi+=v;
      if(v>2000)
         result++;
     }
   m=GetMicrosecondCount()-m;
   m/=1000;
   printf("<int>: %d ms for %d iterations",m,iterations);
   printf("result = %d sum=%lli",result,sumi);

///TESTING DOUBLE
   result=0;
   double sumd=0;
   m=GetMicrosecondCount();
   for(int i=0;i<iterations;i++)
     {
      double v=Add(arrD1[i],arrD2[i]);
      sumd+=v;
      if(v>2000.)
         result++;
     }
   m=GetMicrosecondCount()-m;
   m/=1000;
   printf("<double>: %d ms for %d iterations",m,iterations);
   printf("result = %d sum=%f",result,sumd);

  }
//+------------------------------------------------------------------+

//template<typename T>
//T Add(const T num1, const T num2)
//{
//   return num1+num2;
//}

double Add(const double num1,const double num2)
  {
   return num1+num2;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int Add(const int num1,const int num2)
  {
   return num1+num2;
  }
//+------------------------------------------------------------------+
